
using Apache.Qpid.Buffer;
using System.Text;

namespace Apache.Qpid.Framing
{
  ///
  /// This class is autogenerated
  /// Do not modify.
  ///
  /// @author Code Generator Script by robert.j.greig@jpmorgan.com
  public class BasicDeliverBody : AMQMethodBody , IEncodableAMQDataBlock
  {
    public const int CLASS_ID = 60; 	
    public const int METHOD_ID = 60; 	

    public string ConsumerTag;    
    public ulong DeliveryTag;    
    public bool Redelivered;    
    public string Exchange;    
    public string RoutingKey;    
     

    protected override ushort Clazz
    {
        get
        {
            return 60;
        }
    }
   
    protected override ushort Method
    {
        get
        {
            return 60;
        }
    }

    protected override uint BodySize
    {
    get
    {
        
        return (uint)
        (uint)EncodingUtils.EncodedShortStringLength(ConsumerTag)+
            8 /*DeliveryTag*/+
            1 /*Redelivered*/+
            (uint)EncodingUtils.EncodedShortStringLength(Exchange)+
            (uint)EncodingUtils.EncodedShortStringLength(RoutingKey)		 
        ;
         
    }
    }

    protected override void WriteMethodPayload(ByteBuffer buffer)
    {
        EncodingUtils.WriteShortStringBytes(buffer, ConsumerTag);
            buffer.Put(DeliveryTag);
            EncodingUtils.WriteBooleans(buffer, new bool[]{Redelivered});
            EncodingUtils.WriteShortStringBytes(buffer, Exchange);
            EncodingUtils.WriteShortStringBytes(buffer, RoutingKey);
            		 
    }

    protected override void PopulateMethodBodyFromBuffer(ByteBuffer buffer)
    {
        ConsumerTag = EncodingUtils.ReadShortString(buffer);
        DeliveryTag = buffer.GetUInt64();
        bool[] bools = EncodingUtils.ReadBooleans(buffer);Redelivered = bools[0];
        Exchange = EncodingUtils.ReadShortString(buffer);
        RoutingKey = EncodingUtils.ReadShortString(buffer);
        		 
    }

    public override string ToString()
    {
        StringBuilder buf = new StringBuilder(base.ToString());
        buf.Append(" ConsumerTag: ").Append(ConsumerTag);
        buf.Append(" DeliveryTag: ").Append(DeliveryTag);
        buf.Append(" Redelivered: ").Append(Redelivered);
        buf.Append(" Exchange: ").Append(Exchange);
        buf.Append(" RoutingKey: ").Append(RoutingKey);
         
        return buf.ToString();
    }

    public static AMQFrame CreateAMQFrame(ushort channelId, string ConsumerTag, ulong DeliveryTag, bool Redelivered, string Exchange, string RoutingKey)
    {
        BasicDeliverBody body = new BasicDeliverBody();
        body.ConsumerTag = ConsumerTag;
        body.DeliveryTag = DeliveryTag;
        body.Redelivered = Redelivered;
        body.Exchange = Exchange;
        body.RoutingKey = RoutingKey;
        		 
        AMQFrame frame = new AMQFrame();
        frame.Channel = channelId;
        frame.BodyFrame = body;
        return frame;
    }
} 
}
