/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#include <sstream>

#include <AMQP_ServerProxy.h>
#include <AMQFrame.h>
#include <AccessRequestBody.h>
#include <AccessRequestOkBody.h>
#include <BasicAckBody.h>
#include <BasicCancelBody.h>
#include <BasicCancelOkBody.h>
#include <BasicConsumeBody.h>
#include <BasicConsumeOkBody.h>
#include <BasicDeliverBody.h>
#include <BasicGetBody.h>
#include <BasicGetEmptyBody.h>
#include <BasicGetOkBody.h>
#include <BasicPublishBody.h>
#include <BasicQosBody.h>
#include <BasicQosOkBody.h>
#include <BasicRecoverBody.h>
#include <BasicRecoverOkBody.h>
#include <BasicRejectBody.h>
#include <BasicReturnBody.h>
#include <ChannelAlertBody.h>
#include <ChannelCloseBody.h>
#include <ChannelCloseOkBody.h>
#include <ChannelFlowBody.h>
#include <ChannelFlowOkBody.h>
#include <ChannelOpenBody.h>
#include <ChannelOpenOkBody.h>
#include <ConnectionCloseBody.h>
#include <ConnectionCloseOkBody.h>
#include <ConnectionOpenBody.h>
#include <ConnectionOpenOkBody.h>
#include <ConnectionRedirectBody.h>
#include <ConnectionSecureBody.h>
#include <ConnectionSecureOkBody.h>
#include <ConnectionStartBody.h>
#include <ConnectionStartOkBody.h>
#include <ConnectionTuneBody.h>
#include <ConnectionTuneOkBody.h>
#include <DtxSelectBody.h>
#include <DtxSelectOkBody.h>
#include <DtxStartBody.h>
#include <DtxStartOkBody.h>
#include <ExchangeBoundBody.h>
#include <ExchangeBoundOkBody.h>
#include <ExchangeDeclareBody.h>
#include <ExchangeDeclareOkBody.h>
#include <ExchangeDeleteBody.h>
#include <ExchangeDeleteOkBody.h>
#include <FileAckBody.h>
#include <FileCancelBody.h>
#include <FileCancelOkBody.h>
#include <FileConsumeBody.h>
#include <FileConsumeOkBody.h>
#include <FileDeliverBody.h>
#include <FileOpenBody.h>
#include <FileOpenOkBody.h>
#include <FilePublishBody.h>
#include <FileQosBody.h>
#include <FileQosOkBody.h>
#include <FileRejectBody.h>
#include <FileReturnBody.h>
#include <FileStageBody.h>
#include <QueueBindBody.h>
#include <QueueBindOkBody.h>
#include <QueueDeclareBody.h>
#include <QueueDeclareOkBody.h>
#include <QueueDeleteBody.h>
#include <QueueDeleteOkBody.h>
#include <QueuePurgeBody.h>
#include <QueuePurgeOkBody.h>
#include <StreamCancelBody.h>
#include <StreamCancelOkBody.h>
#include <StreamConsumeBody.h>
#include <StreamConsumeOkBody.h>
#include <StreamDeliverBody.h>
#include <StreamPublishBody.h>
#include <StreamQosBody.h>
#include <StreamQosOkBody.h>
#include <StreamReturnBody.h>
#include <TestContentBody.h>
#include <TestContentOkBody.h>
#include <TestIntegerBody.h>
#include <TestIntegerOkBody.h>
#include <TestStringBody.h>
#include <TestStringOkBody.h>
#include <TestTableBody.h>
#include <TestTableOkBody.h>
#include <TunnelRequestBody.h>
#include <TxCommitBody.h>
#include <TxCommitOkBody.h>
#include <TxRollbackBody.h>
#include <TxRollbackOkBody.h>
#include <TxSelectBody.h>
#include <TxSelectOkBody.h>

namespace qpid {
namespace framing {

AMQP_ServerProxy::AMQP_ServerProxy(OutputHandler* out, u_int8_t major, u_int8_t minor) :
    AMQP_ServerOperations(major, minor),
    version(major, minor),
    out(out),
    access(out, this),
    basic(out, this),
    channel(out, this),
    connection(out, this),
    dtx(out, this),
    exchange(out, this),
    file(out, this),
    queue(out, this),
    stream(out, this),
    test(out, this),
    tunnel(out, this),
    tx(out, this)
{}

	// Inner class instance get methods
	
AMQP_ServerProxy::Access& AMQP_ServerProxy::getAccess()
{
    return access;
}

AMQP_ServerProxy::Basic& AMQP_ServerProxy::getBasic()
{
    return basic;
}

AMQP_ServerProxy::Channel& AMQP_ServerProxy::getChannel()
{
    return channel;
}

AMQP_ServerProxy::Connection& AMQP_ServerProxy::getConnection()
{
    return connection;
}

AMQP_ServerProxy::Dtx& AMQP_ServerProxy::getDtx()
{
    return dtx;
}

AMQP_ServerProxy::Exchange& AMQP_ServerProxy::getExchange()
{
    return exchange;
}

AMQP_ServerProxy::File& AMQP_ServerProxy::getFile()
{
    return file;
}

AMQP_ServerProxy::Queue& AMQP_ServerProxy::getQueue()
{
    return queue;
}

AMQP_ServerProxy::Stream& AMQP_ServerProxy::getStream()
{
    return stream;
}

AMQP_ServerProxy::Test& AMQP_ServerProxy::getTest()
{
    return test;
}

AMQP_ServerProxy::Tunnel& AMQP_ServerProxy::getTunnel()
{
    return tunnel;
}

AMQP_ServerProxy::Tx& AMQP_ServerProxy::getTx()
{
    return tx;
}

	// Inner class implementation

// ==================== class Access ====================
void AMQP_ServerProxy::Access::request( u_int16_t channel,
                    const string& realm,
                    bool exclusive,
                    bool passive,
                    bool active,
                    bool write,
                    bool read )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new AccessRequestBody( parent->getProtocolVersion(),
                         realm,
                         exclusive,
                         passive,
                         active,
                         write,
                         read )));
}


// ==================== class Basic ====================
void AMQP_ServerProxy::Basic::ack( u_int16_t channel,
                    u_int64_t deliveryTag,
                    bool multiple )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicAckBody( parent->getProtocolVersion(),
                         deliveryTag,
                         multiple )));
}


void AMQP_ServerProxy::Basic::cancel( u_int16_t channel,
                    const string& consumerTag,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicCancelBody( parent->getProtocolVersion(),
                         consumerTag,
                         nowait )));
}


void AMQP_ServerProxy::Basic::consume( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    const string& consumerTag,
                    bool noLocal,
                    bool noAck,
                    bool exclusive,
                    bool nowait,
                    const FieldTable& arguments )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicConsumeBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         consumerTag,
                         noLocal,
                         noAck,
                         exclusive,
                         nowait,
                         arguments )));
}


void AMQP_ServerProxy::Basic::get( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    bool noAck )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicGetBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         noAck )));
}


void AMQP_ServerProxy::Basic::publish( u_int16_t channel,
                    u_int16_t ticket,
                    const string& exchange,
                    const string& routingKey,
                    bool mandatory,
                    bool immediate )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicPublishBody( parent->getProtocolVersion(),
                         ticket,
                         exchange,
                         routingKey,
                         mandatory,
                         immediate )));
}


void AMQP_ServerProxy::Basic::qos( u_int16_t channel,
                    u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    bool global )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicQosBody( parent->getProtocolVersion(),
                         prefetchSize,
                         prefetchCount,
                         global )));
}


void AMQP_ServerProxy::Basic::recover( u_int16_t channel,
                    bool requeue )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicRecoverBody( parent->getProtocolVersion(),
                         requeue )));
}


void AMQP_ServerProxy::Basic::reject( u_int16_t channel,
                    u_int64_t deliveryTag,
                    bool requeue )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new BasicRejectBody( parent->getProtocolVersion(),
                         deliveryTag,
                         requeue )));
}


// ==================== class Channel ====================
void AMQP_ServerProxy::Channel::close( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelCloseBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId )));
}


void AMQP_ServerProxy::Channel::closeOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelCloseOkBody( parent->getProtocolVersion() )));
}


void AMQP_ServerProxy::Channel::flow( u_int16_t channel,
                    bool active )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelFlowBody( parent->getProtocolVersion(),
                         active )));
}


void AMQP_ServerProxy::Channel::flowOk( u_int16_t channel,
                    bool active )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelFlowOkBody( parent->getProtocolVersion(),
                         active )));
}


void AMQP_ServerProxy::Channel::open( u_int16_t channel,
                    const string& outOfBand )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ChannelOpenBody( parent->getProtocolVersion(),
                         outOfBand )));
}


// ==================== class Connection ====================
void AMQP_ServerProxy::Connection::close( u_int16_t channel,
                    u_int16_t replyCode,
                    const string& replyText,
                    u_int16_t classId,
                    u_int16_t methodId )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionCloseBody( parent->getProtocolVersion(),
                         replyCode,
                         replyText,
                         classId,
                         methodId )));
}


void AMQP_ServerProxy::Connection::closeOk( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionCloseOkBody( parent->getProtocolVersion() )));
}


void AMQP_ServerProxy::Connection::open( u_int16_t channel,
                    const string& virtualHost,
                    const string& capabilities,
                    bool insist )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionOpenBody( parent->getProtocolVersion(),
                         virtualHost,
                         capabilities,
                         insist )));
}


void AMQP_ServerProxy::Connection::secureOk( u_int16_t channel,
                    const string& response )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionSecureOkBody( parent->getProtocolVersion(),
                         response )));
}


void AMQP_ServerProxy::Connection::startOk( u_int16_t channel,
                    const FieldTable& clientProperties,
                    const string& mechanism,
                    const string& response,
                    const string& locale )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionStartOkBody( parent->getProtocolVersion(),
                         clientProperties,
                         mechanism,
                         response,
                         locale )));
}


void AMQP_ServerProxy::Connection::tuneOk( u_int16_t channel,
                    u_int16_t channelMax,
                    u_int32_t frameMax,
                    u_int16_t heartbeat )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ConnectionTuneOkBody( parent->getProtocolVersion(),
                         channelMax,
                         frameMax,
                         heartbeat )));
}


// ==================== class Dtx ====================
void AMQP_ServerProxy::Dtx::select( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new DtxSelectBody( parent->getProtocolVersion() )));
}


void AMQP_ServerProxy::Dtx::start( u_int16_t channel,
                    const string& dtxIdentifier )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new DtxStartBody( parent->getProtocolVersion(),
                         dtxIdentifier )));
}


// ==================== class Exchange ====================
void AMQP_ServerProxy::Exchange::declare( u_int16_t channel,
                    u_int16_t ticket,
                    const string& exchange,
                    const string& type,
                    bool passive,
                    bool durable,
                    bool autoDelete,
                    bool internal,
                    bool nowait,
                    const FieldTable& arguments )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ExchangeDeclareBody( parent->getProtocolVersion(),
                         ticket,
                         exchange,
                         type,
                         passive,
                         durable,
                         autoDelete,
                         internal,
                         nowait,
                         arguments )));
}


void AMQP_ServerProxy::Exchange::delete_( u_int16_t channel,
                    u_int16_t ticket,
                    const string& exchange,
                    bool ifUnused,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new ExchangeDeleteBody( parent->getProtocolVersion(),
                         ticket,
                         exchange,
                         ifUnused,
                         nowait )));
}


// ==================== class File ====================
void AMQP_ServerProxy::File::ack( u_int16_t channel,
                    u_int64_t deliveryTag,
                    bool multiple )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileAckBody( parent->getProtocolVersion(),
                         deliveryTag,
                         multiple )));
}


void AMQP_ServerProxy::File::cancel( u_int16_t channel,
                    const string& consumerTag,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileCancelBody( parent->getProtocolVersion(),
                         consumerTag,
                         nowait )));
}


void AMQP_ServerProxy::File::consume( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    const string& consumerTag,
                    bool noLocal,
                    bool noAck,
                    bool exclusive,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileConsumeBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         consumerTag,
                         noLocal,
                         noAck,
                         exclusive,
                         nowait )));
}


void AMQP_ServerProxy::File::open( u_int16_t channel,
                    const string& identifier,
                    u_int64_t contentSize )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileOpenBody( parent->getProtocolVersion(),
                         identifier,
                         contentSize )));
}


void AMQP_ServerProxy::File::openOk( u_int16_t channel,
                    u_int64_t stagedSize )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileOpenOkBody( parent->getProtocolVersion(),
                         stagedSize )));
}


void AMQP_ServerProxy::File::publish( u_int16_t channel,
                    u_int16_t ticket,
                    const string& exchange,
                    const string& routingKey,
                    bool mandatory,
                    bool immediate,
                    const string& identifier )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FilePublishBody( parent->getProtocolVersion(),
                         ticket,
                         exchange,
                         routingKey,
                         mandatory,
                         immediate,
                         identifier )));
}


void AMQP_ServerProxy::File::qos( u_int16_t channel,
                    u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    bool global )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileQosBody( parent->getProtocolVersion(),
                         prefetchSize,
                         prefetchCount,
                         global )));
}


void AMQP_ServerProxy::File::reject( u_int16_t channel,
                    u_int64_t deliveryTag,
                    bool requeue )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileRejectBody( parent->getProtocolVersion(),
                         deliveryTag,
                         requeue )));
}


void AMQP_ServerProxy::File::stage( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new FileStageBody( parent->getProtocolVersion() )));
}


// ==================== class Queue ====================
void AMQP_ServerProxy::Queue::bind( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    const string& exchange,
                    const string& routingKey,
                    bool nowait,
                    const FieldTable& arguments )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueueBindBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         exchange,
                         routingKey,
                         nowait,
                         arguments )));
}


void AMQP_ServerProxy::Queue::declare( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    bool passive,
                    bool durable,
                    bool exclusive,
                    bool autoDelete,
                    bool nowait,
                    const FieldTable& arguments )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueueDeclareBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         passive,
                         durable,
                         exclusive,
                         autoDelete,
                         nowait,
                         arguments )));
}


void AMQP_ServerProxy::Queue::delete_( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    bool ifUnused,
                    bool ifEmpty,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueueDeleteBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         ifUnused,
                         ifEmpty,
                         nowait )));
}


void AMQP_ServerProxy::Queue::purge( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new QueuePurgeBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         nowait )));
}


// ==================== class Stream ====================
void AMQP_ServerProxy::Stream::cancel( u_int16_t channel,
                    const string& consumerTag,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamCancelBody( parent->getProtocolVersion(),
                         consumerTag,
                         nowait )));
}


void AMQP_ServerProxy::Stream::consume( u_int16_t channel,
                    u_int16_t ticket,
                    const string& queue,
                    const string& consumerTag,
                    bool noLocal,
                    bool exclusive,
                    bool nowait )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamConsumeBody( parent->getProtocolVersion(),
                         ticket,
                         queue,
                         consumerTag,
                         noLocal,
                         exclusive,
                         nowait )));
}


void AMQP_ServerProxy::Stream::publish( u_int16_t channel,
                    u_int16_t ticket,
                    const string& exchange,
                    const string& routingKey,
                    bool mandatory,
                    bool immediate )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamPublishBody( parent->getProtocolVersion(),
                         ticket,
                         exchange,
                         routingKey,
                         mandatory,
                         immediate )));
}


void AMQP_ServerProxy::Stream::qos( u_int16_t channel,
                    u_int32_t prefetchSize,
                    u_int16_t prefetchCount,
                    u_int32_t consumeRate,
                    bool global )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new StreamQosBody( parent->getProtocolVersion(),
                         prefetchSize,
                         prefetchCount,
                         consumeRate,
                         global )));
}


// ==================== class Test ====================
void AMQP_ServerProxy::Test::content( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestContentBody( parent->getProtocolVersion() )));
}


void AMQP_ServerProxy::Test::contentOk( u_int16_t channel,
                    u_int32_t contentChecksum )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestContentOkBody( parent->getProtocolVersion(),
                         contentChecksum )));
}


void AMQP_ServerProxy::Test::integer( u_int16_t channel,
                    u_int8_t integer1,
                    u_int16_t integer2,
                    u_int32_t integer3,
                    u_int64_t integer4,
                    u_int8_t operation )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestIntegerBody( parent->getProtocolVersion(),
                         integer1,
                         integer2,
                         integer3,
                         integer4,
                         operation )));
}


void AMQP_ServerProxy::Test::integerOk( u_int16_t channel,
                    u_int64_t result )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestIntegerOkBody( parent->getProtocolVersion(),
                         result )));
}


void AMQP_ServerProxy::Test::string_( u_int16_t channel,
                    const string& string1,
                    const string& string2,
                    u_int8_t operation )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestStringBody( parent->getProtocolVersion(),
                         string1,
                         string2,
                         operation )));
}


void AMQP_ServerProxy::Test::stringOk( u_int16_t channel,
                    const string& result )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestStringOkBody( parent->getProtocolVersion(),
                         result )));
}


void AMQP_ServerProxy::Test::table( u_int16_t channel,
                    const FieldTable& table,
                    u_int8_t integerOp,
                    u_int8_t stringOp )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestTableBody( parent->getProtocolVersion(),
                         table,
                         integerOp,
                         stringOp )));
}


void AMQP_ServerProxy::Test::tableOk( u_int16_t channel,
                    u_int64_t integerResult,
                    const string& stringResult )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TestTableOkBody( parent->getProtocolVersion(),
                         integerResult,
                         stringResult )));
}


// ==================== class Tunnel ====================
void AMQP_ServerProxy::Tunnel::request( u_int16_t channel,
                    const FieldTable& metaData )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TunnelRequestBody( parent->getProtocolVersion(),
                         metaData )));
}


// ==================== class Tx ====================
void AMQP_ServerProxy::Tx::commit( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TxCommitBody( parent->getProtocolVersion() )));
}


void AMQP_ServerProxy::Tx::rollback( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TxRollbackBody( parent->getProtocolVersion() )));
}


void AMQP_ServerProxy::Tx::select( u_int16_t channel )
{
    out->send( new AMQFrame(parent->getProtocolVersion(), channel,
        new TxSelectBody( parent->getProtocolVersion() )));
}


} /* namespace framing */
} /* namespace qpid */
