/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_AccessRequestBody__
#define qpid_framing_AccessRequestBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class AccessRequestBody : public AMQMethodBody
{
	// Method field declarations

    string realm;
    bool exclusive;
    bool passive;
    bool active;
    bool write;
    bool read;
     

public:
    typedef boost::shared_ptr<AccessRequestBody> shared_ptr;

	// Constructors and destructors

    AccessRequestBody(ProtocolVersion& version,
        const string& realm,
        bool exclusive,
        bool passive,
        bool active,
        bool write,
        bool read
        ) :
        AMQMethodBody(version),
        realm(realm),
        exclusive(exclusive),
        passive(passive),
        active(active),
        write(write),
        read(read)
    { }


    inline AccessRequestBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline AccessRequestBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~AccessRequestBody() {}
    
    // Attribute get methods

    inline const string& getRealm() { return realm; }
    inline bool getExclusive() { return exclusive; }
    inline bool getPassive() { return passive; }
    inline bool getActive() { return active; }
    inline bool getWrite() { return write; }
    inline bool getRead() { return read; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "AccessRequest: ";
        out << "realm=" << realm;
        out << "; exclusive=" << exclusive;
        out << "; passive=" << passive;
        out << "; active=" << active;
        out << "; write=" << write;
        out << "; read=" << read;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 30;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 10;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + realm.length(); /* realm: shortstr */
        size += 1; /* Combinded bits: [exclusive, passive, active, write, read] */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(realm); /* realm: shortstr */
        u_int8_t flags_5[1] = {0};
        flags_5[0] |= exclusive << 0; /* exclusive: bit */
        flags_5[0] |= passive << 1; /* passive: bit */
        flags_5[0] |= active << 2; /* active: bit */
        flags_5[0] |= write << 3; /* write: bit */
        flags_5[0] |= read << 4; /* read: bit */
        buffer.putOctet(flags_5[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(realm); /* realm: shortstr */
        u_int8_t flags_5[1];
        flags_5[0] = buffer.getOctet();
        exclusive = (1 << 0) & flags_5[0]; /* exclusive: bit */
        passive = (1 << 1) & flags_5[0]; /* passive: bit */
        active = (1 << 2) & flags_5[0]; /* active: bit */
        write = (1 << 3) & flags_5[0]; /* write: bit */
        read = (1 << 4) & flags_5[0]; /* read: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getAccessHandler()->request(channel,
                    realm,
                    exclusive,
                    passive,
                    active,
                    write,
                    read
                    );
    }


}; // class AccessRequestBody


} // namespace framing
} // namespace qpid

#endif

