/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ConnectionOpenOkBody__
#define qpid_framing_ConnectionOpenOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ConnectionOpenOkBody : public AMQMethodBody
{
	// Method field declarations

    string knownHosts;
     

public:
    typedef boost::shared_ptr<ConnectionOpenOkBody> shared_ptr;

	// Constructors and destructors

    ConnectionOpenOkBody(ProtocolVersion& version,
        const string& knownHosts
        ) :
        AMQMethodBody(version),
        knownHosts(knownHosts)
    { }


    inline ConnectionOpenOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ConnectionOpenOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ConnectionOpenOkBody() {}
    
    // Attribute get methods

    inline const string& getKnownHosts() { return knownHosts; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ConnectionOpenOk: ";
        out << "knownHosts=" << knownHosts;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 10;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 41;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + knownHosts.length(); /* knownHosts: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(knownHosts); /* knownHosts: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(knownHosts); /* knownHosts: shortstr */
    }       



}; // class ConnectionOpenOkBody


} // namespace framing
} // namespace qpid

#endif

