/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ConnectionTuneBody__
#define qpid_framing_ConnectionTuneBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ConnectionTuneBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t channelMax;
    u_int32_t frameMax;
    u_int16_t heartbeat;
     

public:
    typedef boost::shared_ptr<ConnectionTuneBody> shared_ptr;

	// Constructors and destructors

    ConnectionTuneBody(ProtocolVersion& version,
        u_int16_t channelMax,
        u_int32_t frameMax,
        u_int16_t heartbeat
        ) :
        AMQMethodBody(version),
        channelMax(channelMax),
        frameMax(frameMax),
        heartbeat(heartbeat)
    { }


    inline ConnectionTuneBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ConnectionTuneBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ConnectionTuneBody() {}
    
    // Attribute get methods

    inline u_int16_t getChannelMax() { return channelMax; }
    inline u_int32_t getFrameMax() { return frameMax; }
    inline u_int16_t getHeartbeat() { return heartbeat; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ConnectionTune: ";
        out << "channelMax=" << channelMax;
        out << "; frameMax=" << frameMax;
        out << "; heartbeat=" << heartbeat;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 10;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 30;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* channelMax: short */
        size += 4; /* frameMax: long */
        size += 2; /* heartbeat: short */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(channelMax); /* channelMax: short */
        buffer.putLong(frameMax); /* frameMax: long */
        buffer.putShort(heartbeat); /* heartbeat: short */
    }

    inline void decodeContent(Buffer& buffer)
    {
        channelMax = buffer.getShort(); /* channelMax: short */
        frameMax = buffer.getLong(); /* frameMax: long */
        heartbeat = buffer.getShort(); /* heartbeat: short */
    }       



}; // class ConnectionTuneBody


} // namespace framing
} // namespace qpid

#endif

