/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ExchangeDeclareBody__
#define qpid_framing_ExchangeDeclareBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ExchangeDeclareBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t ticket;
    string exchange;
    string type;
    bool passive;
    bool durable;
    bool autoDelete;
    bool internal;
    bool nowait;
    FieldTable arguments;
     

public:
    typedef boost::shared_ptr<ExchangeDeclareBody> shared_ptr;

	// Constructors and destructors

    ExchangeDeclareBody(ProtocolVersion& version,
        u_int16_t ticket,
        const string& exchange,
        const string& type,
        bool passive,
        bool durable,
        bool autoDelete,
        bool internal,
        bool nowait,
        const FieldTable& arguments
        ) :
        AMQMethodBody(version),
        ticket(ticket),
        exchange(exchange),
        type(type),
        passive(passive),
        durable(durable),
        autoDelete(autoDelete),
        internal(internal),
        nowait(nowait),
        arguments(arguments)
    { }


    inline ExchangeDeclareBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ExchangeDeclareBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ExchangeDeclareBody() {}
    
    // Attribute get methods

    inline u_int16_t getTicket() { return ticket; }
    inline const string& getExchange() { return exchange; }
    inline const string& getType() { return type; }
    inline bool getPassive() { return passive; }
    inline bool getDurable() { return durable; }
    inline bool getAutoDelete() { return autoDelete; }
    inline bool getInternal() { return internal; }
    inline bool getNowait() { return nowait; }
    inline const FieldTable& getArguments() { return arguments; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ExchangeDeclare: ";
        out << "ticket=" << ticket;
        out << "; exchange=" << exchange;
        out << "; type=" << type;
        out << "; passive=" << passive;
        out << "; durable=" << durable;
        out << "; autoDelete=" << autoDelete;
        out << "; internal=" << internal;
        out << "; nowait=" << nowait;
        out << "; arguments=" << arguments;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 40;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 10;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* ticket: short */
        size += 1 + exchange.length(); /* exchange: shortstr */
        size += 1 + type.length(); /* type: shortstr */
        size += 1; /* Combinded bits: [passive, durable, autoDelete, internal, nowait] */
        size += arguments.size(); /* arguments: table */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(type); /* type: shortstr */
        u_int8_t flags_8[1] = {0};
        flags_8[0] |= passive << 0; /* passive: bit */
        flags_8[0] |= durable << 1; /* durable: bit */
        flags_8[0] |= autoDelete << 2; /* autoDelete: bit */
        flags_8[0] |= internal << 3; /* internal: bit */
        flags_8[0] |= nowait << 4; /* nowait: bit */
        buffer.putOctet(flags_8[0]);
        buffer.putFieldTable(arguments); /* arguments: table */
    }

    inline void decodeContent(Buffer& buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(type); /* type: shortstr */
        u_int8_t flags_8[1];
        flags_8[0] = buffer.getOctet();
        passive = (1 << 0) & flags_8[0]; /* passive: bit */
        durable = (1 << 1) & flags_8[0]; /* durable: bit */
        autoDelete = (1 << 2) & flags_8[0]; /* autoDelete: bit */
        internal = (1 << 3) & flags_8[0]; /* internal: bit */
        nowait = (1 << 4) & flags_8[0]; /* nowait: bit */
        buffer.getFieldTable(arguments); /* arguments: table */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getExchangeHandler()->declare(channel,
                    ticket,
                    exchange,
                    type,
                    passive,
                    durable,
                    autoDelete,
                    internal,
                    nowait,
                    arguments
                    );
    }


}; // class ExchangeDeclareBody


} // namespace framing
} // namespace qpid

#endif

