/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ExchangeDeleteBody__
#define qpid_framing_ExchangeDeleteBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ExchangeDeleteBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t ticket;
    string exchange;
    bool ifUnused;
    bool nowait;
     

public:
    typedef boost::shared_ptr<ExchangeDeleteBody> shared_ptr;

	// Constructors and destructors

    ExchangeDeleteBody(ProtocolVersion& version,
        u_int16_t ticket,
        const string& exchange,
        bool ifUnused,
        bool nowait
        ) :
        AMQMethodBody(version),
        ticket(ticket),
        exchange(exchange),
        ifUnused(ifUnused),
        nowait(nowait)
    { }


    inline ExchangeDeleteBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ExchangeDeleteBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ExchangeDeleteBody() {}
    
    // Attribute get methods

    inline u_int16_t getTicket() { return ticket; }
    inline const string& getExchange() { return exchange; }
    inline bool getIfUnused() { return ifUnused; }
    inline bool getNowait() { return nowait; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ExchangeDelete: ";
        out << "ticket=" << ticket;
        out << "; exchange=" << exchange;
        out << "; ifUnused=" << ifUnused;
        out << "; nowait=" << nowait;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 40;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 20;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* ticket: short */
        size += 1 + exchange.length(); /* exchange: shortstr */
        size += 1; /* Combinded bits: [ifUnused, nowait] */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(exchange); /* exchange: shortstr */
        u_int8_t flags_3[1] = {0};
        flags_3[0] |= ifUnused << 0; /* ifUnused: bit */
        flags_3[0] |= nowait << 1; /* nowait: bit */
        buffer.putOctet(flags_3[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(exchange); /* exchange: shortstr */
        u_int8_t flags_3[1];
        flags_3[0] = buffer.getOctet();
        ifUnused = (1 << 0) & flags_3[0]; /* ifUnused: bit */
        nowait = (1 << 1) & flags_3[0]; /* nowait: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getExchangeHandler()->delete_(channel,
                    ticket,
                    exchange,
                    ifUnused,
                    nowait
                    );
    }


}; // class ExchangeDeleteBody


} // namespace framing
} // namespace qpid

#endif

