/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_FileRejectBody__
#define qpid_framing_FileRejectBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class FileRejectBody : public AMQMethodBody
{
	// Method field declarations

    u_int64_t deliveryTag;
    bool requeue;
     

public:
    typedef boost::shared_ptr<FileRejectBody> shared_ptr;

	// Constructors and destructors

    FileRejectBody(ProtocolVersion& version,
        u_int64_t deliveryTag,
        bool requeue
        ) :
        AMQMethodBody(version),
        deliveryTag(deliveryTag),
        requeue(requeue)
    { }


    inline FileRejectBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline FileRejectBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~FileRejectBody() {}
    
    // Attribute get methods

    inline u_int64_t getDeliveryTag() { return deliveryTag; }
    inline bool getRequeue() { return requeue; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "FileReject: ";
        out << "deliveryTag=" << deliveryTag;
        out << "; requeue=" << requeue;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 70;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 100;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 8; /* deliveryTag: longlong */
        size += 1; /* requeue: bit */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putLongLong(deliveryTag); /* deliveryTag: longlong */
        u_int8_t flags_1[1] = {0};
        flags_1[0] |= requeue << 0; /* requeue: bit */
        buffer.putOctet(flags_1[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        deliveryTag = buffer.getLongLong(); /* deliveryTag: longlong */
        u_int8_t flags_1[1];
        flags_1[0] = buffer.getOctet();
        requeue = (1 << 0) & flags_1[0]; /* requeue: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getFileHandler()->reject(channel,
                    deliveryTag,
                    requeue
                    );
    }


}; // class FileRejectBody


} // namespace framing
} // namespace qpid

#endif

