/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_QueueDeleteOkBody__
#define qpid_framing_QueueDeleteOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class QueueDeleteOkBody : public AMQMethodBody
{
	// Method field declarations

    u_int32_t messageCount;
     

public:
    typedef boost::shared_ptr<QueueDeleteOkBody> shared_ptr;

	// Constructors and destructors

    QueueDeleteOkBody(ProtocolVersion& version,
        u_int32_t messageCount
        ) :
        AMQMethodBody(version),
        messageCount(messageCount)
    { }


    inline QueueDeleteOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline QueueDeleteOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~QueueDeleteOkBody() {}
    
    // Attribute get methods

    inline u_int32_t getMessageCount() { return messageCount; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "QueueDeleteOk: ";
        out << "messageCount=" << messageCount;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 50;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 41;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 4; /* messageCount: long */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putLong(messageCount); /* messageCount: long */
    }

    inline void decodeContent(Buffer& buffer)
    {
        messageCount = buffer.getLong(); /* messageCount: long */
    }       



}; // class QueueDeleteOkBody


} // namespace framing
} // namespace qpid

#endif

