/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_StreamDeliverBody__
#define qpid_framing_StreamDeliverBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class StreamDeliverBody : public AMQMethodBody
{
	// Method field declarations

    string consumerTag;
    u_int64_t deliveryTag;
    string exchange;
    string queue;
     

public:
    typedef boost::shared_ptr<StreamDeliverBody> shared_ptr;

	// Constructors and destructors

    StreamDeliverBody(ProtocolVersion& version,
        const string& consumerTag,
        u_int64_t deliveryTag,
        const string& exchange,
        const string& queue
        ) :
        AMQMethodBody(version),
        consumerTag(consumerTag),
        deliveryTag(deliveryTag),
        exchange(exchange),
        queue(queue)
    { }


    inline StreamDeliverBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline StreamDeliverBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~StreamDeliverBody() {}
    
    // Attribute get methods

    inline const string& getConsumerTag() { return consumerTag; }
    inline u_int64_t getDeliveryTag() { return deliveryTag; }
    inline const string& getExchange() { return exchange; }
    inline const string& getQueue() { return queue; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "StreamDeliver: ";
        out << "consumerTag=" << consumerTag;
        out << "; deliveryTag=" << deliveryTag;
        out << "; exchange=" << exchange;
        out << "; queue=" << queue;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 80;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 60;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + consumerTag.length(); /* consumerTag: shortstr */
        size += 8; /* deliveryTag: longlong */
        size += 1 + exchange.length(); /* exchange: shortstr */
        size += 1 + queue.length(); /* queue: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(consumerTag); /* consumerTag: shortstr */
        buffer.putLongLong(deliveryTag); /* deliveryTag: longlong */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(queue); /* queue: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(consumerTag); /* consumerTag: shortstr */
        deliveryTag = buffer.getLongLong(); /* deliveryTag: longlong */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(queue); /* queue: shortstr */
    }       



}; // class StreamDeliverBody


} // namespace framing
} // namespace qpid

#endif

