/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_TestStringBody__
#define qpid_framing_TestStringBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class TestStringBody : public AMQMethodBody
{
	// Method field declarations

    string string1;
    string string2;
    u_int8_t operation;
     

public:
    typedef boost::shared_ptr<TestStringBody> shared_ptr;

	// Constructors and destructors

    TestStringBody(ProtocolVersion& version,
        const string& string1,
        const string& string2,
        u_int8_t operation
        ) :
        AMQMethodBody(version),
        string1(string1),
        string2(string2),
        operation(operation)
    { }


    inline TestStringBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline TestStringBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~TestStringBody() {}
    
    // Attribute get methods

    inline const string& getString1() { return string1; }
    inline const string& getString2() { return string2; }
    inline u_int8_t getOperation() { return operation; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "TestString: ";
        out << "string1=" << string1;
        out << "; string2=" << string2;
        out << "; operation=" << (int)operation;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 120;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 20;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + string1.length(); /* string1: shortstr */
        size += 4 + string2.length(); /* string2: longstr */
        size += 1; /* operation: octet */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(string1); /* string1: shortstr */
        buffer.putLongString(string2); /* string2: longstr */
        buffer.putOctet(operation); /* operation: octet */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(string1); /* string1: shortstr */
        buffer.getLongString(string2); /* string2: longstr */
        operation = buffer.getOctet(); /* operation: octet */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getTestHandler()->string_(channel,
                    string1,
                    string2,
                    operation
                    );
    }


}; // class TestStringBody


} // namespace framing
} // namespace qpid

#endif

