/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_TestTableBody__
#define qpid_framing_TestTableBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class TestTableBody : public AMQMethodBody
{
	// Method field declarations

    FieldTable table;
    u_int8_t integerOp;
    u_int8_t stringOp;
     

public:
    typedef boost::shared_ptr<TestTableBody> shared_ptr;

	// Constructors and destructors

    TestTableBody(ProtocolVersion& version,
        const FieldTable& table,
        u_int8_t integerOp,
        u_int8_t stringOp
        ) :
        AMQMethodBody(version),
        table(table),
        integerOp(integerOp),
        stringOp(stringOp)
    { }


    inline TestTableBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline TestTableBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~TestTableBody() {}
    
    // Attribute get methods

    inline const FieldTable& getTable() { return table; }
    inline u_int8_t getIntegerOp() { return integerOp; }
    inline u_int8_t getStringOp() { return stringOp; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "TestTable: ";
        out << "table=" << table;
        out << "; integerOp=" << (int)integerOp;
        out << "; stringOp=" << (int)stringOp;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 120;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 30;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += table.size(); /* table: table */
        size += 1; /* integerOp: octet */
        size += 1; /* stringOp: octet */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putFieldTable(table); /* table: table */
        buffer.putOctet(integerOp); /* integerOp: octet */
        buffer.putOctet(stringOp); /* stringOp: octet */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getFieldTable(table); /* table: table */
        integerOp = buffer.getOctet(); /* integerOp: octet */
        stringOp = buffer.getOctet(); /* stringOp: octet */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getTestHandler()->table(channel,
                    table,
                    integerOp,
                    stringOp
                    );
    }


}; // class TestTableBody


} // namespace framing
} // namespace qpid

#endif

